from backstage.config import UPLOAD_PATH_MAP
import os
import shutil
from flask import render_template, Blueprint, request, redirect, url_for
import flask
from flask_cors import CORS, cross_origin
from flask.helpers import make_response, send_file, send_from_directory
from werkzeug.wrappers import Response
import requests
from PIL import Image
from urllib.parse import urlparse
import uuid


#from backstage.utils.routes import update_manage_table

upload_app = Blueprint('upload', __name__)


@upload_app.route('/backstage/upload/<path:iurl>', methods=['POST'])
def upload_post(iurl):
    #bdata = request.stream.read()
    filepath = ""
    itype = ""
    #aa = request.get_data()
    if iurl == "title":
        itype = iurl
        filepath = iurl
    else:
        itype = iurl[0:iurl.find("/")]
        filepath = iurl[iurl.rfind("/")+1:]

    if request.method == 'POST':

        # check if the post request has the file part
        # print(request.full_path)
        """ if 'file' not in request.files:
            #flash('No file part')
            return redirect(request.url) """
        if len(request.files) == 0:
            aa = {"success": 0}
            return aa
        else:
            file = request.files['image']

            # If the user does not select a file, the browser submits an
            # empty file without a filename.
            """ if file.filename == '':
                #flash('No selected file')
                return redirect(request.url) """

            if file:
                #filename = secure_filename(file.filename)

                #fname = str(uuid.uuid4()) + file.filename[file.filename.rfind("."):]
                #sitepath = UPLOAD_PATH_MAP[0][0] + filepath[filepath.rfind("/")+1:] + "/img/"
                if filepath == "title":
                    sitepath = UPLOAD_PATH_MAP[0][0] + "../../static/img/collection/"
                else:
                    if itype == "blog":
                        sitepath = UPLOAD_PATH_MAP[0][0] + "../blog/" + filepath + "/img/"
                    else:
                        sitepath = UPLOAD_PATH_MAP[0][0] + filepath + "/img/"
                oimgtype = file.filename[file.filename.rfind(".")+1:]
                oimgtypeName = oimgtype
                if oimgtype.lower() == 'jpg':
                    oimgtypeName = 'jpeg'

                wfname = str(uuid.uuid4()) + ".webp"
                owfname = wfname.replace('webp', oimgtype)
                #fullpath = UPLOAD_PATH_MAP[0][0] + filepath[filepath.rfind("/")+1:] + "\\img\\" + fname
                #print(UPLOAD_PATH_MAP[0][1] + filepath[filepath.rfind("/")+1:] + "/img/" + fname)
                # file.save(fullpath)
                #image_object = Image.open(fullpath)
                #print(request.args.get('url', type=str))
                wpath = os.getcwd() + "/backstage/upload/" + filepath+"/img/"
                owpath = os.getcwd() + "/backstage/upload/" + filepath+"/img/orig/"
                #fullpath = wpath + fname
                if not os.path.exists(wpath):
                    os.makedirs(wpath)
                if not os.path.exists(owpath):
                    os.makedirs(owpath)
                if not os.path.exists(sitepath):
                    os.makedirs(sitepath)
                # file.save(fullpath)
                image_object = Image.open(file)
                image_object.save(owpath+owfname, oimgtypeName)
                if image_object.size[0] > 1000:
                    image_object.thumbnail(size=((1600, 1600)))
                image_object.save(wpath+wfname, 'webp')
                image_object.save(sitepath+wfname, 'webp')
                #file.save(os.getcwd()+ "/backstage/upload/img/"+ fname)
                # return redirect(url_for('download_file', name=file.filename))
                aa = {"success": 1, "file": {"url": "/backstage/upload/" +
                                             filepath+"/img/" + wfname, "width": image_object.width, "height": image_object.height}}
                # aa = {"success": 1, "file": {"url": UPLOAD_PATH_MAP[0][1] + filepath[filepath.rfind(
                #    "/")+1:] + "/img/" + fname, "width": image_object.width, "height": image_object.height}}
                return aa
        if request.method == 'GET':
            print('GET')
            # print(request.files)
            # print(request.form)

        # print(requests.post("/backstage/upload"))
        aa = {"success": 1, "file": {"url": "http://www.choozmo.com/images/logo%20%281%29.webp", }}
        return aa


@upload_app.route('/backstage/upload/<path:filepath>', methods=['GET'])
def upload_get(filepath):
    # print(filepath)
    #print(os.getcwd() + "/backstage/upload/"+filepath, filepath[filepath.rfind("/")+1:])
    #aa = {"success" : 1,"file": { "url" : "https://www.tesla.com/tesla_theme/assets/img/_vehicle_redesign/roadster_and_semi/roadster/hero.jpg", } }
    # return redirect(url_for('upload.upload_get',filename=filename), code=301)
    # return send_from_directory(os.getcwd() + "/backstage/upload/"+filepath, filepath[filepath.rfind("/")+1:])

    return send_file(os.getcwd() + "/backstage/upload/"+filepath)


@upload_app.route('/backstage/getimage/<path:iurl>', methods=['POST', 'GET'])
def get_image(iurl):

    itype = iurl[0:iurl.find("/")]
    filepath = iurl[iurl.rfind("/")+1:]

    # print(request.get_json()['url'])
    if itype == "blog":
        sitepath = UPLOAD_PATH_MAP[0][0] + "../blog/" + filepath + "/img/"
    else:
        sitepath = UPLOAD_PATH_MAP[0][0] + filepath + "/img/"
    #sitepath = UPLOAD_PATH_MAP[0][0] + filepath + "/img/"
    oimgtype = str(request.get_json()['url'])[str(request.get_json()['url']).rfind(".")+1:]
    oimgtypeName = oimgtype
    if oimgtype.lower() == 'jpg':
        oimgtypeName = 'jpeg'
    # fname = str(uuid.uuid4()) + str(request.get_json()
    #                                ['url'])[str(request.get_json()['url']).rfind("."):]
    wfname = str(uuid.uuid4()) + ".webp"
    owfname = wfname.replace('webp', oimgtype)
    wpath = os.getcwd() + "/backstage/upload/" + filepath+"/img/"
    owpath = os.getcwd() + "/backstage/upload/" + filepath+"/img/orig/"
    """ fullpath = wpath + fname
    if not os.path.exists(wpath):
        os.makedirs(wpath)
    f = open(fullpath, 'wb')
    f.write(requests.get(request.get_json()['url']).content)
    f.close() """
    if not os.path.exists(wpath):
        os.makedirs(wpath)
    if not os.path.exists(owpath):
        os.makedirs(owpath)
    if not os.path.exists(sitepath):
        os.makedirs(sitepath)
    image_object = Image.open(requests.get(request.get_json()['url'], stream=True).raw)
    image_object.save(owpath+owfname, oimgtypeName)
    if image_object.size[0] > 1000:
        image_object.thumbnail(size=((1600, 1600)))
    image_object.save(wpath+wfname, 'webp')
    image_object.save(sitepath+wfname, 'webp')
    # send_file()
    #aa = {"success" : 1,"file": { "url" : "http://localhost:9000/backstage/upload/avatar1.jpg", } }
    #resp = make_response(open(os.getcwd()+ "/backstage/upload/" + fname, 'br').read(), 301)
    #resp.content_type = "image/jpeg"
    #resp.content_encoding = "Unicode"
    # return redirect(request.get_json()['url'], code=301)
    aa = {"success": 1, "file": {"url": "/backstage/upload/" +
                                 filepath+"/img/" + wfname, "width": image_object.width, "height": image_object.height}}
    return aa


@upload_app.route('/backstage/modTitle/<path:filepath>', methods=['GET'])
def modify_title(filepath):
    oldPath = UPLOAD_PATH_MAP[0][0] + filepath.split('/')[0]
    newPath = UPLOAD_PATH_MAP[0][0] + filepath.split('/')[1]
    # os.renames(oldPath,newPath)
    """ if os.path.exists(newPath):
        return {"success" : 0, "message" : "New directory exists."} """
    """ shutil.copytree(oldPath, newPath)
    shutil.rmtree(oldPath) """
    print(oldPath + ' => ' + newPath)

    return {"success": 1}
